{Behai, Mik 1995..98, we keep the source copyright, although we release for
public as technical reference}

unit VEdit;

interface
{$R KEYSETS.RES}
uses
  winprocs, wintypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TStandardCode = (TVNI, VISCII, TVPS);

  TVEdit = class(TEdit)
    public
      constructor Create(AOwner : TComponent); override;
      PROCEDURE LOADED; OVERRIDE;
    protected
      procedure KeyPress(var Key: Char); override;
    private
      FCode : TStandardCode;
    PROCEDURE FCodeWRITE(VALUE:TStandardCode);
    published
      property CodeUse : TStandardCode  read FCode write FCodeWRITE default TVNI;
  end;

procedure Register;
function TheVietChar(var old_char : char; diacritic : char; which : byte) : char;

type
  Viet_Key = record
    ori_key : byte;   {The original key.}
    new_key : byte;   {The new key.}
  end;

Viet_Key_Array = array[1..710] of Viet_Key;
Implementation
var
  VKA: Viet_Key_Array;

procedure READres(res_id : string; VAR res_data; SIZE : LONGINT);
VAR H : THANDLE;
    p : pointer;
    F : INTEGER;
BEGIN
P := STRALLOC(LENGTH(RES_ID));
P := strpcopy(p,res_id);
H := FindResource(HINSTANCE, p ,RT_RCDATA);
STRDISPOSE(P);
IF H > 0 THEN
 begin
   F := ACCESSRESOURCE(HINSTANCE, H);
   IF F > 0 THEN
   FILEREAD(F,RES_DATA,SIZE);
 end;
END;


function TheVietChar(var old_char : char; diacritic : char; which : byte) : char;
var
  j, spos, epos: integer;
begin
  TheVietChar := diacritic;

  if (old_char = #0) then
    exit;

 {[1,1] [2,118] [3,237] [4,356] [5,475] [6,591] [7,651] [8,687] [9,709]}

  case diacritic of
    '1': begin
           spos := 1;
           epos := 118;
         end;

    '2': begin
           spos := 118;
           epos := 237;
         end;

    '3': begin
           spos := 237;
           epos := 356;
         end;

    '4': begin
           spos := 356;
           epos := 475;
         end;

    '5': begin
           spos := 475;
           epos := 591;
         end;

    '6': begin
           spos := 591;
           epos := 651;
         end;

    '7': begin
           spos := 651;
           epos := 687;
         end;

    '8': begin
           spos := 687;
           epos := 709;
         end;

    '9': begin
           spos := 709;
           epos := 710;
         end;
    else
         exit;
  end;

    for j := spos to epos do
    if (char(VKA[j].ori_key) = old_char) then
      begin
        TheVietChar := char(VKA[j].new_key);
        exit;
      end;

end;

PROCEDURE TVEdit.LOADED;
BEGIN
 INHERITED LOADED;
  CASE FCODE OF
   TVNI:  READRES('VNI',VKA,SIZEOF(Viet_Key_Array));
   VISCII:  READRES('VIS',VKA,SIZEOF(Viet_Key_Array));
   TVPS : READRES('VPS',VKA,SIZEOF(Viet_Key_Array));
  END;
END;
PROCEDURE TVEdit.FCodeWRITE(VALUE:TStandardCode);
BEGIN
IF  FCode <> VALUE THEN
BEGIN
  FCODE   := VALUE;
  CASE FCODE OF
   TVNI:  READRES('VNI',VKA,SIZEOF(Viet_Key_Array));
   VISCII:  READRES('VIS',VKA,SIZEOF(Viet_Key_Array));
   TVPS : READRES('VPS',VKA,SIZEOF(Viet_Key_Array));
  END;
END;
END;

constructor TVEdit.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  FCode       := TVNI;
end;

procedure TVEdit.KeyPress(var Key: Char);
var
  PrevChar : char;
  SText    : string;
  res      : char;
begin

  inherited KeyPress(Key);

  if (Key = #13) or (Key = #8) or (Key = #27) then
    exit;

  SText := Text;

  PrevChar := SText[SelStart];

  res := TheVietChar(PrevChar, Key, ord(CodeUse) + 1);

  if (res <> Key) then
    begin
      SelStart := SelStart - 1;
      SelLength := 1;
      Key := res;
    end;

end;

procedure Register;
begin
  RegisterComponents('bhCustom', [TVEdit]);
end;
end.
